
/////////////////////////////////////////////////////////////
//
// Source file for AudioOptionsForm
//
//    This file is generated by RapidApp 1.1
//
//    This class is derived from AudioOptionsFormUI which 
//    implements the user interface created in 
//    the interface builder. This class contains virtual
//    functions that are called from the user interface.
//
//    When you modify this source, limit your changes to 
//    modifying the sections between the "//--- Start/End editable code block" markers
//
//    This will allow the builder to integrate changes more easily
//
//    This class is a ViewKit user interface "component".
//    For more information on how components are used, see the
//    "ViewKit Programmers' Manual", and the RapidApp
//    User's Guide.
/////////////////////////////////////////////////////////////

#include "AudioOptionsForm.h"
#include <Vk/VkEZ.h>
#include <Sgm/Dial.h> 
#include <Xm/Form.h> 
#include <Xm/Label.h> 
#include <Xm/TextF.h> 
#include <Xm/ToggleB.h> 
#include <Vk/VkResource.h>

extern void VkUnimplemented(Widget, const char *);

///////////////////////////////////////////////////////////////////////////////
// The following non-container widgets are created by AudioOptionsFormUI and are
// available as protected data members inherited by this class
//
//  XmLabel		    _label11
//  XmLabel		    _label10
//  XmToggleButton		    _micOffToggle
//  XmToggleButton		    _muteToggle
//  XmLabel		    _label5
//  XmLabel		    _label4
//  SgDial		    _micDial
//  SgDial		    _volumeDial
//  XmTextField		    _audioModeText
//  XmTextField		    _audioCompressionText
//
///////////////////////////////////////////////////////////////////////////////


//---- Start editable code block: headers and declarations

#include <Xm/ToggleB.h>
#include <Xm/TextF.h>
#include <Sgm/Dial.h>

#include "BV_Session_Control.h"
#include "BV.h"

//---- End editable code block: headers and declarations



//---- AudioOptionsForm Constructor

AudioOptionsForm::AudioOptionsForm(const char *name, Widget parent) : 
                   AudioOptionsFormUI(name, parent) 
{ 
    // This constructor calls AudioOptionsFormUI(parent, name)
    // which calls AudioOptionsFormUI::create() to create
    // the widgets for this component. Any code added here
    // is called after the component's interface has been built

    //---- Start editable code block: AudioOptionsForm constructor

  BV_Session_Control *ctrl = BV_Session_Control::instance();
  options_ = ctrl->get_options();
  ctrl->destroy();

  this->set_options();

    //---- End editable code block: AudioOptionsForm constructor



} // End Constructor



AudioOptionsForm::AudioOptionsForm(const char *name) : 
                   AudioOptionsFormUI(name) 
 { 
    // This constructor calls AudioOptionsFormUI(name)
    // which does not create any widgets. Usually, this
    // constructor is not used

    //---- Start editable code block: AudioOptionsForm constructor 2


    //---- End editable code block: AudioOptionsForm constructor 2



} // End Constructor



AudioOptionsForm::~AudioOptionsForm()
{
    // The base class destructors are responsible for
    // destroying all widgets and objects used in this component.
    // Only additional items created directly in this class
    // need to be freed here.

    //---- Start editable code block: AudioOptionsForm destructor


    //---- End editable code block: AudioOptionsForm destructor



}


const char * AudioOptionsForm::className() // classname
{
    return ("AudioOptionsForm");
} // End className()





///////////////////////////////////////////////////////////////////
// C-callable creation function, for importing class into rapidapp
///////////////////////////////////////////////////////////////////


extern "C" VkComponent * CreateAudioOptionsForm( const char *name, Widget parent ) 
{  
    VkComponent *obj =  new AudioOptionsForm ( name, parent );
    obj->show();

    return ( obj );
} // End CreateAudioOptionsForm


///////////////////////////////////////////////////////////////////
// Function for importing this class into rapidapp
// This function is only used by RapidApp.
///////////////////////////////////////////////////////////////////


typedef void (AudioOptionsForm::*Method) (void);
struct FunctionMap {
  char  *resource;  Method method;  char  *code;
  char  *type;
};


extern "C" void* RegisterAudioOptionsFormInterface()
{ 
    // This structure registers information about this class
    // that allows RapidApp to create and manipulate an instance.
    // Each entry provides a resource name that will appear in the
    // resource manager palette when an instance of this class is
    // selected, the relative address of the member function that
    // should be invoked when the resource is set, the name of the
    // member function as a string, and the type of the single 
    // argument to this function. All functions must have the form
    //  
    //  void memberFunction(Type);
    //
    // where "Type" is one of const char *, Boolean, or int. Use
    // XmRString, XmRBoolean, or XmRInt to describe the argument type


    static FunctionMap map[] = {
    //---- Start editable code block: AudioOptionsFormUI resource table

      // { "resourceName", (Method) &AudioOptionsForm::setAttribute, "setAttribute", XmRString},
    //---- End editable code block: AudioOptionsFormUI resource table
      { NULL }, // MUST be NULL terminated
    };

    return map;
} // End RegisterAudioOptionsFormInterface()






//---- End of generated code

//---- Start editable code block: End of generated code

void AudioOptionsForm::set_options()
{
  XmTextFieldSetString(_audioModeText, "Full Duplex");
  switch(options_->connection)
    {
    case _modem28:
      XmTextFieldSetString(_audioCompressionText, "GSM-13 kbps");
      break;

    case _isdn:
      XmTextFieldSetString(_audioCompressionText, "ADPCM-32 kbps");
      break;

    case _isdn2:
      XmTextFieldSetString(_audioCompressionText, "ADPCM-32 kbps");
      break;

    case _lan:
      XmTextFieldSetString(_audioCompressionText, "PCM-128 kbps");
      break;

    }

  XtVaSetValues(_volumeDial,
		XmNminimum, 0,
		XmNmaximum, 270,		
		SgNstartAngle, 45,
		SgNangleRange, 270,
		XmNvalue, options_->volume*270/255,
		NULL);

  XtVaSetValues(_micDial,
		XmNminimum, 0,
		XmNmaximum, 270,		
		SgNstartAngle, 45,
		SgNangleRange, 270,
		XmNvalue, options_->mic_volume*270/255,
		NULL);
  
  if(options_->volume == 0)
    XmToggleButtonSetState(_muteToggle, True, False);

  if(options_->mic_volume == 0)
    XmToggleButtonSetState(_micOffToggle, True, False);

}

void AudioOptionsForm::get_options()
{
  short tmp;

  XtVaGetValues(_volumeDial,
		XmNvalue, &tmp,
		NULL);
  options_->volume = tmp * 255 / 270;

  XtVaGetValues(_micDial,
		XmNvalue, &tmp,
		NULL);
  options_->mic_volume = tmp * 255 / 360;

  if(XmToggleButtonGetState(_muteToggle) == True)
    options_->volume = 0;

  if(XmToggleButtonGetState(_muteToggle) == True)
    options_->mic_volume = 0;
  
}

//---- End editable code block: End of generated code


